<?php 
    /**
     * @brief zeroboard4 export tool
     * @author zero (zero@xpressengine.com)
     **/

    @set_time_limit(0);
    // zMigration class require
    require_once('./lib.inc.php');
    require_once('./zMigration.class.php');
    $oMigration = new zMigration();

    // 사용되는 변수의 선언
    $path = $_GET['path'];
    if(substr($path,-1)=='/') $path = substr($path,0,strlen($path)-1);
    $target_module = $_GET['target_module'];
    $module_id = $_GET['module_id'];
    $start = $_GET['start'];
    $limit_count = $_GET['limit_count'];
    $exclude_attach = $_GET['exclude_attach']=='Y'?'Y':'N';
    $filename = $_GET['filename'];
    $charset = $_GET['charset'];
    $db_type = $_GET['db_type'];

    // 입력받은 path를 이용하여 db 정보를 구함
    $db_info = getDBInfo($path);
    if(!$db_info) {
        header("HTTP/1.0 404 Not Found");
        exit();
    }

    $db_info->db_type = $db_type;

    // zMigration DB 정보 설정
    $oMigration->setDBInfo($db_info);

    // 대상 정보 설정
    $oMigration->setModuleType($target_module, $module_id);

    // 언어 설정
    $oMigration->setCharset($charset, 'UTF-8');

    // 다운로드 파일명 설정
    $oMigration->setFilename($filename);

    // 경로 지정
    $oMigration->setPath($path);

    // db 접속
    if($oMigration->dbConnect()) {
        header("HTTP/1.0 404 Not Found");
        exit();
    }

    // limit쿼리 생성 (mysql외에도 적용하기 위함)
    $limit_query = $oMigration->getLimitQuery($start, $limit_count);

    /**
     * 회원 정보 export일 회원 관련 정보를 모두 가져와서 처리
     **/
    if($target_module == 'member') {

        // 이미지닉네임, 이미지마크 경로, 프로필 이미지, 서명 구함
        $image_nickname_path = sprintf('%s/icon/private_name/',$path);
        $image_mark_path = sprintf('%s/icon/private_icon/',$path);

        // 헤더 정보를 출력
        $oMigration->setItemCount($limit_count);
        $oMigration->printHeader();

        // 회원정보를 역순(오래된 순)으로 구해옴
        $query = "select * from zetyx_member_table order by no asc ".$limit_query;
        $member_result = $oMigration->query($query);

        // 회원정보를 하나씩 돌면서 migration format에 맞춰서 변수화 한후에 printMemberItem 호출
        while($member_info = mysql_fetch_object($member_result)) {
            $obj = null;

            // 일반 변수들
            $obj->user_id = $member_info->user_id;
            $obj->password = $member_info->password;
            $obj->user_name = $member_info->name;
            $obj->nick_name = $member_info->name;
            $obj->email = $member_info->email;
            $obj->homepage = $member_info->homepage;
            $obj->blog = $member_info->blog;
            $obj->birthday = date("YmdHis", $member_info->birth);
            $obj->allow_mailing = $member_info->mailing!=0?'Y':'N';
            $obj->point = $member_info->point1+$member_info->point2;
            $obj->regdate = date("YmdHis", $member_info->reg_date);
            $obj->signature = '';

            // 이미지이름, 이미지마크, 프로필이미지등은 경로를 입력
            $obj->image_nickname = sprintf("%s%d.gif", $image_nickname_path, $member_info->no);
            $obj->image_mark = sprintf("%s%d.gif", $image_mark_path, $member_info->no);
            $obj->profile_image = '';

            // 확장변수 칸에 입력된 변수들은 XE의 멤버 확장변수를 통해서 사용될 수 있음
            $obj->extra_vars = array(
                'icq' => $member_info->icq,
                'aol' => $member_info->aol,
                'msn' => $member_info->msn,
                'job' => $member_info->job,
                'hobby' => $member_info->hobby,
                'home_address' => $member_info->home_address,
                'home_tel' => $member_info->home_tel,
                'office_address' => $member_info->office_address,
                'office_tel' => $member_info->office_tel,
                'handphone' => $member_info->handphone,
            );

            $oMigration->printMemberItem($obj);
        }

        // 푸터 정보를 출력
        $oMigration->printFooter();

    /**
     * 쪽지 정보
     * 쪽지의 경우 받은 쪽지함+보관함을 모두 받아와서 처리함.
     **/
    } else if($target_module == 'message') {

        // 헤더 정보를 출력
        $oMigration->setItemCount($limit_count);
        $oMigration->printHeader();

        // 쪽지 정보를 오래된 순부터 구해옴
        $query = '
            select 
                b.user_id as receiver, 
                c.user_id as sender,
                a.subject as title,
                a.memo as content,
                a.readed as readed,
                a.reg_date as regdate,
                a.reg_date as readed_date
            from 
                zetyx_get_memo a, 
                zetyx_member_table b, 
                zetyx_member_table c 
            where 
                a.member_no = b.no and 
                a.member_from = c.no 
            order by a.no '.$limit_query;

        $message_result = $oMigration->query($query);

        // 쪽지를 하나씩 돌면서 migration format에 맞춰서 변수화 한후에 printMessageItem 호출
        while($obj = mysql_fetch_object($message_result)) {

            // 일반 변수들
            if($obj->readed) $obj->readed = 'Y'; 
            else $obj->readed = 'N';
            $obj->regdate = date("YmdHis", $obj->regdate);
            $obj->readed_date = date("YmdHis", $obj->readed_date);
            $obj->content = nl2br($obj->content);

            $oMigration->printMessageItem($obj);
        }

        // 헤더 정보를 출력
        $oMigration->printFooter();

    /**
     * 게시판 정보 export일 경우
     **/
    } else {

        // dqrevolution 스킨 사용하는지 테이블 검사
        $query = "show tables like 'dq_revolution'";
        $result = $oMigration->query($query);
        $tmp = mysql_fetch_array($result);

        if($tmp[0]) $use_dq = true;
        else $use_dq = false;

        // 그림창고, 첨부파일 디렉토리 경로를 미리 구함
        $image_box_path = sprintf('%s/icon/member_image_box',$path);

        // 게시판 정보를 구함
        $query = "select * from zetyx_admin_table where name='".$module_id."'";
        $module_info_result = $oMigration->query($query);
        $module_info = mysql_fetch_object($module_info_result);

        // 헤더 정보를 출력
        $oMigration->setItemCount($limit_count);
        $oMigration->printHeader();

        // 카테고리를 구함
        if($module_info->use_category) {
            $query = "select * from rankup_category";
            $category_result = $oMigration->query($query);
            while($category_info= mysql_fetch_object($category_result)) {
                $category_list[$category_info->no] = $category_info->list_name;
            }
        }

        // 카테고리 정보 출력
        $oMigration->printCategoryItem($category_list);

        // 게시글은 역순(오래된 순서)으로 구함
        $query = sprintf('select * from rankup_news_content order by no asc %s', $limit_query);
        $document_result = $oMigration->query($query);

        while($document_info = mysql_fetch_object($document_result)) {
            $obj = null;
			$wdate = str_replace('-', '', $document_info->wdate);
			$wwdate = str_replace(':', '', $wdate);
            $obj->category = $category_list[$document_info->category];
            $obj->title = $document_info->subject;
            $obj->content = $document_info->content;
            $obj->readed_count = $document_info->hnum;
            $obj->voted_count = $document_info->onum;
            $obj->user_id = $document_info->uid;
            $obj->nick_name = $document_info->author;
            $obj->email = $document_info->email;
            $obj->homepage = null;
            $obj->password = null;
            $obj->ipaddress = $document_info->uip;
            $obj->allow_comment = 'Y';
            $obj->lock_comment = 'N';
            $obj->allow_trackback = 'Y';
            $obj->is_secret = 'N';
            $obj->regdate =  str_replace(' ', '', $wwdate);
            $obj->update = $document_info->mdate;
            $obj->tags = $document_info->keyword;

            // 게시판의 기타 정보를 구함 (다른 기타 정보가 있을 경우 추가하면 됨 (20개까지 가능)
            if($document_info->subtitle) $obj->extra_vars[] = $document_info->subtitle;
            if($document_info->media) $obj->extra_vars[] = $document_info->media;
            if($document_info->copyright) $obj->extra_vars[] = $document_info->copyright;

            // 게시글의 댓글을 구함
            $comments = array();
            $query = sprintf('select * from rankup_news_opinion where ano = %d order by no asc', $document_info->no);
            $comment_result = $oMigration->query($query);
            while($comment_info = mysql_fetch_object($comment_result)) {
                $comment_obj = null;
                // 현재 사용중인 primary key값을 sequence로 넣어두면 parent와 결합하여 depth를 이루어서 importing함
                $comment_obj->sequence = $comment_obj->no;

                // 제로보드4는 댓글에 depth가 없어서 parent를 0으로 세팅. 다른 프로그램이라면 부모 고유값을 입력해주면 됨
                $comment_obj->parent = 0; 
				$cwdate = str_replace('-', '', $comment_info->wdate);
				$ccwdate = str_replace(':', '', $comment_info->cwdate);
                $comment_obj->is_secret = 'N';
                $comment_obj->content = nl2br($comment_info->content);
                $comment_obj->voted_count = 0;
                $comment_obj->notify_message = 'N';
                $comment_obj->password = $comment_info->upass;
                $comment_obj->user_id = null;
                $comment_obj->nick_name = $comment_info->uname;
                $comment_obj->email = null;
                $comment_obj->homepage = null;
                $comment_obj->update = null;
                $comment_obj->regdate = str_replace(' ', '', $cwwdate);
                $comment_obj->ipaddress = $comment_info->uip;

                $comments[] = $comment_obj;

            }
            $obj->comments = $comments;


            $oMigration->printPostItem($document_info->no, $obj, $exclude_attach);
        }

        // 헤더 정보를 출력
        $oMigration->printFooter();
    }
?>
